/****************************************************************************************
 * Copyright (c) 1999 Microsoft Corporation.  All Rights Reserved.
 *
 * File:
 *  BasicHdr.h
 *
 * Description:
 *	
 *
 *
 ***************************************************************************************/
#ifndef __BASICHDR_H__
#define __BASICHDR_H__

#define _WIN32_DCOM


/***************************************************************************************
 ********************                                               ********************
 ********************             Common Includes                   ********************
 ********************                                               ********************
 ***************************************************************************************/
#include "math.h"
#include "stdio.h"
#include "stdlib.h"
#include "stdarg.h"
#include "limits.h"
#include "malloc.h"
#include "string.h"
#include "windows.h"

#include "cor.h"
#include "corprof.h"    	

/***************************************************************************************
 ********************                                               ********************
 ********************              Basic Macros                     ********************
 ********************                                               ********************
 ***************************************************************************************/
//  
// alias' for COM method signatures
//
#define COM_METHOD( TYPE ) TYPE STDMETHODCALLTYPE


//
// max length for arrays
//
#define MAX_LENGTH 256


//
// debug macro for DebugBreak
//
#undef _DbgBreak
#ifdef _X86_
	#define _DbgBreak() __asm { int 3 }
#else
	#define _DbgBreak() DebugBreak()
#endif // _X86_


//                        
// basic I/O macros
//
#define TEXT_OUT( message ) printf( "%s", message );
#define TEXT_OUTLN( message ) printf( "%s\n", message );


//
// assert on false
//
#define _ASSERT_( expression ) \
{ \
	if ( !(expression) ) \
    _LaunchDebugger( #expression, __FILE__, __LINE__ );	\
} \

//
// exception macro
//
#define _THROW_EXCEPTION( message ) \
{ \
    throw new BaseException( message );	\
} \


// the compiler complains about the exception not being
// used in the exception handler---it is being rethrown.
// ---turn off warning! 
#pragma warning ( disable: 4101 )

// C++ exception handler used, but unwind semantics
// are not enabled---turn off warning!
#pragma warning ( disable: 4530 )  

#endif // __BASICHDR_H__

// End of File
 