/****************************************************************************************
 * Copyright (c) 1999 Microsoft Corporation.  All Rights Reserved.
 *
 * File:
 *  ProfilerBase.h
 *
 * Description:
 *	
 *
 *
 ***************************************************************************************/
#ifndef __PROFILERBASE_H__
#define __PROFILERBASE_H__

#include "BasicHdr.h"

//
// debug dumper
//
void _DDebug( char *format, ... );


//
// launch debugger
//
void _LaunchDebugger( const char *szMsg, const char *szFile, int iLine );


/***************************************************************************************
 ********************                                               ********************
 ********************           BaseException Declaration           ********************
 ********************                                               ********************
 ***************************************************************************************/
class BaseException
{
    public:
        
        BaseException( const char *reason );
        virtual ~BaseException();
        

        virtual void ReportFailure();


    private:

        char *m_reason;
        
}; // BaseException


/***************************************************************************************
 ********************                                               ********************
 ********************            Synchronize Declaration            ********************
 ********************                                               ********************
 ***************************************************************************************/
class Synchronize 
{
	public:
	
    	Synchronize( CRITICAL_SECTION &criticalSection );
		~Synchronize();
        
        
	private:
	
    	CRITICAL_SECTION &m_block;
        
}; // Synchronize    

#endif // __PROFILERBASE_H__

// End of File
